//+------------------------------------------------------------------+
//|                                                TickConverter.mq4 |
//|                           by UHLFXtrade Software K.Yamanouchi    |
//| Since 2017.12.19-27                                                |
//+------------------------------------------------------------------+
#property strict
#property link      "http://www.yamanouchi-katsura.uhl.jp/"
#property copyright "K.Yamanouchi"
#property version   "1.02"
#property description "This Indicator can run on MT4 build after 1090."
#property description "Please enjoy happy scalper life!"
#property description "<include\\myCPanel.mqh> is nessesary if you use control panel."
#property description "Ideas from 'FOREX PRICE ACTION Scalping' By Bob Volman"
#property show_inputs

#include <ChartObjects/ChartObjectsTxtControls.mqh>
#include <Files/FileBin.mqh>

input int ticks=70;    //tick count max : default 70
extern int start_pos=600;  //count of source bars
input bool spreadfree=true;    //ignore spread
input bool notail=false;   //substruct tail(high-low)data from history
input int OmitDigit=1;  //adjust display sub0
input bool piper=true;   //BV's recommendation 1pip unit
input int averagebars=0;   //Bars speed averaging 0,1 => single bar speed
input bool dispSpeedLavel=true;  //Speed Lavel on/off
input color LabelColor=clrWhite; //Speed Lavel Color
input int countDelay=300;  //delay incoming tick calculate milseconds
int startsec,stopsec,splitsec;
CFileBin FH;
CChartObjectLabel BSpeed,TSpeed;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   datetime time0;
   ulong    last_fpos;
   long     last_volume;
   int      i,j;
   datetime      cnt=0;  //bars counter
   string bs="",ts="";  //bar speed inner text

//---- History header
   int      file_version=401;
   string   c_copyright;
   string   c_symbol=Symbol()+"T";
   int      i_period=Period();   //at current chart
   int      i_digits=Digits-OmitDigit;
   int      i_unused[13];
   ArrayInitialize(i_unused,0);
   MqlRates rate;
   FH.OpenHistory(c_symbol+(string)i_period+".hst",FILE_BIN|FILE_WRITE|FILE_SHARE_WRITE|FILE_SHARE_READ|FILE_ANSI);
   if(FH.Handle()<0)
      return;
//--- write history file header
   c_copyright="(C)opyright 2003, MetaQuotes Software Corp.";
   FH.WriteInteger(file_version);
   FH.WriteString(c_copyright,64);
   FH.WriteString(c_symbol,12);
   FH.WriteInteger(i_period);
   FH.WriteInteger(i_digits);
   FH.WriteInteger(0);
   FH.WriteInteger(0);
   FH.WriteArray(i_unused,0,13);
   last_fpos=FH.Tell();

//--- write history file
   if(start_pos>Bars) start_pos=Bars; //Number of bars in the current chart
   rate.open=Open[start_pos-1];
   rate.low=Low[start_pos-1];
   rate.high=High[start_pos-1];
   rate.tick_volume=(long)Volume[start_pos-1];
   rate.spread=0; // int 0 filling
   rate.real_volume=0;  // long 0 filling, but this script use this as tick time seconds
   last_volume=rate.tick_volume; //volume memory
   for(i=start_pos; i>=0; i--) //calculate from start_pos bar to 0 at the current chart.
     {
      if(IsStopped()) //script removed
         break;
      time0=Time[i];
      //--- history may be updated
      if(i==0)
         //--- modify index if history was updated
         if(RefreshRates())
            i=iBarShift(NULL,0,time0);
      //--- create tick base rate data
      last_volume+=(long)Volume[i];
      while(last_volume>=0) //split and randomize candle data
        {
         j=0;  //loop counter
         last_volume-=ticks;
         rate.time=cnt; // ..is 0 start and should be increased with updating bar
         if(j==0) //first update
           {
            if(rate.low>Low[i])
               rate.low=Low[i];
            if(rate.high<High[i])
               rate.high=High[i];
            if(notail)
              {
               if(Open[i]<=Close[i])
                 {
                  rate.low=Open[i];
                  rate.high=Close[i];
                 }
               else
                 {
                  rate.low=Close[i];
                  rate.high=Open[i];
                 }
              }
           }
         else    //after update need randomized value
           {
            if(Open[i]<=Close[i])
              {
               rate.low=GetRandom(rate.close,rate.open);
               rate.high=GetRandom(rate.close,rate.high);
               if(notail)
                 {
                  rate.low=Open[i];
                  rate.high=Close[i];
                 }
              }
            else
              {
               rate.low=GetRandom(rate.low,rate.close);
               rate.high=GetRandom(rate.open,rate.close);
               if(notail)
                 {
                  rate.low=Close[i];
                  rate.high=Open[i];
                 }
              }
           }
         //need randomized close value
         if(Open[i]<=Close[i]) rate.close=GetRandom(Open[i],rate.high);
         else rate.close=GetRandom(rate.low,Open[i]);
         rate.tick_volume=ticks;   //the volume is fixed at 'input' ticks
         rate.close=gp(rate.close);
         rate.high=gp(rate.high);
         rate.low=gp(rate.low);
         rate.open=gp(rate.open);
         last_fpos=FH.Tell(); //memory position
         FH.WriteStruct(rate);   //this method moves the position
         cnt++;   //new position need new count(time)
         if(Open[i]<=Close[i]) //next data randomized
           {
            rate.low=GetRandom(rate.close,rate.open);
            rate.high=GetRandom(rate.close,rate.high);
            if(notail)
              {
               rate.low=Open[i];
               rate.high=Close[i];
              }
           }
         else
           {
            rate.low=GetRandom(rate.low,rate.close);
            rate.high=GetRandom(rate.open,rate.close);
            if(notail)
              {
               rate.low=Close[i];
               rate.high=Open[i];
              }
           }
         rate.open=rate.close;
         j++;
        }
      //------while loop end

      //repare data
      last_volume+=ticks;
      rate.tick_volume=last_volume;
      if(rate.low>Low[i])
         rate.low=Low[i];
      if(rate.high<High[i])
         rate.high=High[i];
      if(notail)
        {
         if(Open[i]<=Close[i])
           {
            rate.low=Open[i];
            rate.high=Close[i];
           }
         else
           {
            rate.low=Close[i];
            rate.high=Open[i];
           }
        }
      rate.close=Close[i];
     }
//------for loop end

//finalize history data
   FH.Seek(last_fpos,SEEK_SET);
   rate.close=gp(rate.close);
   rate.high=gp(rate.high);
   rate.low=gp(rate.low);
   rate.open=gp(rate.open);
   FH.WriteStruct(rate);
   FH.Flush();

//--------------------+
//  incoming ticks    |
//--------------------+
   long chart_id=0,id=ChartFirst();
   long ra[];  //rate array
   ArrayResize(ra,averagebars+1);
   ArrayInitialize(ra,0);
   long sumra=0;  //sum rates value
   double cmp;
   datetime ttb=TimeCurrent(),btb=TimeCurrent(),tte=0,bte=0;  //ticktimebegin,bartimebegin,ticktimeend,bartimeend
   long tdiff=0,bdiff=0;  //tick time difference, bar time difference
   static bool spflg=true;   //if exist speed indicator label object
   int op=0;   //Bar and Tick speed Lavel offset option
   if(averagebars) op=50;

   while(!IsStopped()) //Main loop
     {
      //--- check for new rates
      if(RefreshRates()) //check Close[0],Volume[0];
        {
         tte=TimeCurrent();   //tick time end
         tdiff=tte-ttb;
         ts=StringFormat("Latest tick interval %dsec/bar",tdiff*ticks);
         TSpeed.SetString(OBJPROP_TEXT,ts);
         FH.Seek(last_fpos,SEEK_SET);  //rewind current bar data position
         rate.time=cnt-1;

         last_volume++;
         rate.real_volume+=tdiff;
         if(spreadfree==true) cmp=Bid+(Ask-Bid)/2;
         else cmp=Bid;
         if(cmp<rate.low) rate.low=cmp;
         if(cmp>rate.high) rate.high=cmp;
         rate.close=cmp;

         if(last_volume<ticks) //current bar
           {
            rate.tick_volume=last_volume;
            bdiff=tte-btb;
            if(dispSpeedLavel)
              {
               if(averagebars>1) bs=StringFormat("%dBars Average Speed %dsec/bar",averagebars,sumra);
               else bs=StringFormat("%d/%d Current %dsec/bar",last_volume,ticks,bdiff/(last_volume+1)*(ticks+1));   //avoid 0 divide
              }
           }
         else    //close and open bars
           {
            bte=TimeCurrent();   //bar time end
            bdiff=bte-btb;
            rate.tick_volume=ticks;
            rate.real_volume=bdiff;
            if(dispSpeedLavel)
              {
               if(averagebars>1) //averaging multi bars
                 {
                  ra[0]=bdiff;
                  for(i=averagebars;i>0;i--)
                    {
                     ra[i]=ra[i-1];
                     sumra+=ra[i];
                    }
                  sumra/=averagebars;
                  bs=StringFormat("%dBars Average Speed %dsec/bar",averagebars,sumra);
                 }
               else
                 {
                  bs=StringFormat("%d/%d Current %dsec/bar",last_volume,ticks,bdiff/(last_volume+1)*(ticks+1));
                 }
              }
            rate.open=gp(rate.open);   //function gp() normalize value for history recoding.
            rate.close=gp(rate.close);
            rate.high=gp(rate.high);
            rate.low=gp(rate.low);
            //----draw last bar and reset value
            FH.WriteStruct(rate);
            last_fpos=FH.Tell();
            rate.time=cnt;
            rate.open=cmp;
            rate.low=cmp;
            rate.high=cmp;
            rate.close=cmp;
            last_volume=0;
            rate.tick_volume=last_volume;
            rate.real_volume=0;
            cnt++;
            btb=bte;
           }
         ttb=tte;
         FH.WriteStruct(rate);
         FH.Flush();
         if(dispSpeedLavel) BSpeed.SetString(OBJPROP_TEXT,bs);
        }

      //--- target chart is not found yet. it can be opened via Main menu - File - Open offline
      if(chart_id==0)
        {
         while(id>=0)
           {
            //--- find appropriate offline chart
            if(ChartSymbol(id)==c_symbol && ChartPeriod(id)==i_period && ChartGetInteger(id,CHART_IS_OFFLINE))
              {
               chart_id=id;
               ChartSetInteger(chart_id,CHART_AUTOSCROLL,true);
               ChartSetInteger(chart_id,CHART_SHIFT,true);
               ChartNavigate(chart_id,CHART_END);
               ChartRedraw(chart_id);
               PrintFormat("Chart window [%s,%d] found",c_symbol,i_period);
               break;
              }
            //--- enumerate opened charts
            id=ChartNext(id);
            if(spflg && dispSpeedLavel)
              {
               //---show Bars speed
               BSpeed.Create(id,"bs",0,250+op,50);
               BSpeed.Corner(CORNER_RIGHT_LOWER);
               BSpeed.Color(LabelColor);
               BSpeed.FontSize(14);
               //---show Tick speed
               TSpeed.Create(id,"ts",0,250+op,20);
               TSpeed.Corner(CORNER_RIGHT_LOWER);
               TSpeed.Color(LabelColor);
               TSpeed.FontSize(12);
               //---show HLine
               spflg=false;
              }
           }
        }
      ChartSetSymbolPeriod(chart_id,c_symbol,i_period);  //Reflesh chart
      Sleep(countDelay);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   if(FH.Handle()>=0)
     {
      FH.Close();
     }
//CT.Close();
//---
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double GetRandom(double min,double max)
  {
   return NormalizeDouble(min+MathRand()%100/100.0*(max-min), Digits);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double gp(double value)
  {
   double ret=0;
   switch(piper)
     {
      case true:
         ret=NormalizeDouble(value,Digits-1);
         break;
      case false:
         ret=value;
         break;
     }
   return ret;
  }
//+------------------------------------------------------------------+
